diff -uNrd ircd-hybrid-6.3.1.dist/include/m_info.h ircd-hybrid-6.3.1/include/m_info.h
--- ircd-hybrid-6.3.1.dist/include/m_info.h	Fri Dec  7 00:09:27 2001
+++ ircd-hybrid-6.3.1/include/m_info.h	Mon Apr 21 16:03:35 2003
@@ -137,12 +137,6 @@
   { "CRYPT_LINK_PASSWORD", "OFF", 0, "Encrypt Server Passwords" },
 #endif /* CRYPT_LINK_PASSWORD */
 
-#ifdef CUSTOM_ERR
-  { "CUSTOM_ERR", "ON", 0, "Customized error messages" },
-#else
-  { "CUSTOM_ERR", "OFF", 0, "Customized error messages" },
-#endif /* CUSTOM_ERR */
-
 #ifdef DEBUGMODE
   { "DEBUGMODE", "ON", 0, "Debugging Mode" },
 #else
@@ -270,6 +264,12 @@
   { "HIDE_SERVERS_IPS", "OFF", 0, "Hide server's IP's from all users" },
 #endif /* HIDE_SERVERS_IPS */
 
+#ifdef HIDE_SPOOF_IPS
+  { "HIDE_SPOOF_IPS", "ON", 0, "Hide spoofed IP's from all users" },
+#else
+  { "HIDE_SPOOF_IPS", "OFF", 0, "Hide spoofed IP's from all users" },
+#endif /* HIDE_SPOOF_IPS */
+
 #ifdef HPATH
   { "HPATH", HPATH, 0, "Path to Operator Help File" },
 #else
@@ -446,6 +446,12 @@
   { "NO_FAKE_GLINES", "OFF", 0, "Do not allow GLINES from users that do not exist" },
 #endif /* NO_FAKE_GLINES */
 
+#ifdef NO_CREATE_ON_SPLIT
+  { "NO_CREATE_ON_SPLIT", "ON", 0, "Users Cannot Create Channels During a NetSplit" },
+#else
+  { "NO_CREATE_ON_SPLIT", "OFF", 0, "Users Cannot Create Channels During a NetSplit" },
+#endif
+
 #ifdef NO_JOIN_ON_SPLIT
   { "NO_JOIN_ON_SPLIT", "ON", 0, "Users Cannot Join Channels During a NetSplit" },
 #else
@@ -583,12 +589,6 @@
   { "SHOW_INVISIBLE_LUSERS", "OFF", 0, "Show Invisible Clients in LUSERS" },
 #endif /* SHOW_INVISIBLE_LUSERS */
 
-#ifdef SLAVE_SERVERS
-  { "SLAVE_SERVERS", "ON", 0, "Send LOCOPS and K-lines to U: lined Servers" },
-#else
-  { "SLAVE_SERVERS", "OFF", 0, "Send LOCOPS and K-lines to U: lined Servers" },
-#endif /* SLAVE_SERVERS */
-
 #ifdef SPATH
   { "SPATH", SPATH, 0, "Path to Server Executable" },
 #else
@@ -717,6 +717,198 @@
 #else
   { "ZIP_LINKS", "OFF", 0, "Compress Server to Server Links" },
 #endif /* ZIP_LINKS */
+
+/* +fr extensions */
+
+#ifdef SAVE_MAXCLIENT
+  { "SAVE_MAXCLIENT", "ON", 0, "Save LUSERS Statistics in a Persistant File" },
+  { "MXPATH", MXPATH, 0, "LUSERS Savestate File" },
+  { "SAVE_TIME", "", SAVE_TIME, "Time Interval Between Syncs" },
+#else
+  { "SAVE_MAXCLIENT", "OFF", 0, "Save LUSERS Statistics in a Persistant File" },
+#endif
+
+#ifdef XLINE_COMMAND
+  { "XLINE_COMMAND", "ON", 0, "Operator XLINE Command" },
+#else
+  { "XLINE_COMMAND", "OFF", 0, "Operator XLINE Command" },
+#endif
+
+#ifdef CRYPT_AUTH_PASSWORD
+  { "CRYPT_AUTH_PASSWORD", "ON", 0, "Encrypted I: Line Passwords" },
+#else
+  { "CRYPT_AUTH_PASSWORD", "OFF", 0, "Encrypted I: Line Passwords" },
+#endif
+
+#ifdef GECOS_CLICONNECT
+  { "GECOS_CLICONNECT", "ON", 0, "Show Gecos on Client Connect Notices" },
+#else
+  { "GECOS_CLICONNECT", "OFF", 0, "Show Gecos on Client Connect Notices" },
+#endif
+
+#ifdef ANTI_IP_SPOOF
+  { "ANTI_IP_SPOOF", "ON", 0, "Force a client to answer a PONG to register" },
+#else
+  { "ANTI_IP_SPOOF", "OFF", 0, "Force a client to answer a PONG to register" },
+#endif
+
+#ifdef REMOTE_WHOIS_NOTICE
+  { "REMOTE_WHOIS_NOTICE", "ON", 0, "Spy on remote users doing a WHOIS on opers" },
+#else
+  { "REMOTE_WHOIS_NOTICE", "OFF", 0, "Spy on remote users doing a WHOIS on opers" },
+#endif
+
+#ifdef POST_REGISTER
+  { "POST_REGISTER", "ON", 0, "Enable the POST/GET/PUT commands during registration" },
+#else
+  { "POST_REGISTER", "OFF", 0, "Enable the POST/GET/PUT commands during registration" },
+#endif
+
+#ifdef CHECK_CLONE
+  { "CHECK_CLONE", "ON", 0, "Network-Wide Clonebot Checking" },
+#else
+  { "CHECK_CLONE", "OFF", 0, "Network-Wide Clonebot Checking" },
+#endif
+
+#ifdef CHECK_CLONE_LIMIT
+  { "CHECK_CLONE_LIMIT", "", CHECK_CLONE_LIMIT, "Default Maximum Allowed Number of Clones" },
+#else
+  { "CHECK_CLONE_LIMIT", "NONE", 0, "Default Maximum Allowed Number of Clons" },
+#endif
+
+#ifdef CHECK_CLONE_PERIOD
+  { "CHECK_CLONE_PERIOD", "", CHECK_CLONE_PERIOD, "Default Clone Check Period" },
+#else
+  { "CHECK_CLONE_PERIOD", "NONE", 0, "Default Clone Check Period" },
+#endif
+
+#ifdef CHECK_CLONE_DELAY
+  { "CHECK_CLONE_DELAY", "", CHECK_CLONE_DELAY, "Clone Check Delay" },
+#else
+  { "CHECK_CLONE_DELAY", "NONE", 0, "Clone Check Delay" },
+#endif
+
+#ifdef PART_MESSAGES
+  { "PART_MESSAGES", "ON", 0, "Allow PART comments" },
+#else
+  { "PART_MESSAGES", "OFF", 0, "Allow PART comments" },
+#endif
+
+#ifdef SILENCE_ON_BAN
+  { "SILENCE_ON_BAN", "ON", 0, "Banned users cannot speak" },
+#else
+  { "SILENCE_ON_BAN", "OFF", 0, "Banned users cannot speak" },
+#endif
+
+#ifdef TOPIC_UH
+  { "TOPIC_UH", "ON", 0, "Show nick!user@host in topic info" },
+#else
+  { "TOPIC_UH", "OFF", 0, "Show nick!user@host in topic info" },
+#endif
+
+  { "ADMIN_MODE", "ON", 0, "Administrator mode" },
+
+#ifdef FLAGS_COMMAND
+  { "FLAGS_COMMAND", "ON", 0, "csircd like FLAGS command" },
+#else
+  { "FLAGS_COMMAND", "OFF", 0, "csircd like FLAGS command" },
+#endif
+
+#ifdef FLAGS_ANNOUNCE
+  { "FLAGS_ANNOUNCE", "ON", 0, "Notify the user what FLAGS they have on connect" },
+#else
+  { "FLAGS_ANNOUNCE", "OFF", 0, "Notify the user what FLAGS they have on connect" },
+#endif
+
+#ifdef CLIENT_EXIT
+  { "CLIENT_EXIT", "ON", 0, "Mark local client /quit's with Client Exited" },
+#else
+  { "CLIENT_EXIT", "OFF", 0, "Mark local client /quit's with Client Exited" },
+#endif
+
+#ifdef STATS_IGNORED_NOTICE
+  { "STATS_IGNORED_NOTICE", "ON", 0, "Send a notice to users when a STATS is ignored" },
+#else
+  { "STATS_IGNORED_NOTICE", "OFF", 0, "Send a notice to users when a STATS is ignored" },
+#endif
+
+#ifdef WHOIS_TRYAGAIN
+  { "WHOIS_TRYAGAIN", "ON", 0, "Send a 'Load too high' numeric to users with ignored remote WHOIS" },
+#else
+  { "WHOIS_TRYAGAIN", "OFF", 0, "Send a 'Load too high' numeric to users with ignored remote WHOIS" },
+#endif
+
+#ifdef NEG_PORT
+  { "NEG_PORT", "ON", 0, "A negative port in a C: line disables autoconnect" },
+#else
+  { "NEG_PORT", "OFF", 0, "A negative port in a C: line disables autoconnect" },
+#endif
+
+#ifdef DEOPER_NOTICE
+  { "DEOPER_NOTICE", "ON", 0, "Show a notice when opers leave operator status" },
+#else
+  { "DEOPER_NOTICE", "OFF", 0, "Show a notice when opers leave operator status" },
+#endif
+
+#ifdef JUPE_BYPASS
+  { "JUPE_BYPASS", "ON", 0, "Opers can join and speak in juped channels" },
+#else
+  { "JUPE_BYPASS", "OFF", 0, "Opers can join and speak in juped channels" },
+#endif
+
+#ifdef TKLINE_EXPIRE_NOTICE
+  { "TKLINE_EXPIRE_NOTICE", "ON", 0, "Display a notice when a tkline expires" },
+#else
+  { "TKLINE_EXPIRE_NOTICE", "OFF", 0, "Display a notice when a tkline expires" },
+#endif
+
+#ifdef TDLINE_EXPIRE_NOTICE
+  { "TDLINE_EXPIRE_NOTICE", "ON", 0, "Display a notice when a tdline expires" },
+#else
+  { "TDLINE_EXPIRE_NOTICE", "OFF", 0, "Display a notice when a tdline expires" },
+#endif
+
+#ifdef PROPAGATE_AWAY
+  { "PROPAGATE_AWAY", "ON", 0, "Propagate AWAY messages to other servers" },
+#else
+  { "PROPAGATE_AWAY", "OFF", 0, "Propagate AWAY messages to other servers" },
+#endif
+
+#ifdef BURST_AWAY
+  { "BURST_AWAY", "ON", 0, "Send AWAY messages on burst" },
+#else
+  { "BURST_AWAY", "OFF", 0, "Send AWAY messages on burst" },
+#endif
+
+#ifdef REVERT_USERHOST
+  { "REVERT_USERHOST", "ON", 0, "Revert USERHOST to the original behaviour" },
+#else
+  { "REVERT_USERHOST", "OFF", 0, "Revert USERHOST to the original behaviour" },
+#endif
+
+#ifdef WALLCHOPS
+  { "WALLCHOPS", "ON", 0, "Adds WALLCHOPS for ircu client compatability" },
+#else
+  { "WALLCHOPS", "OFF", 0, "Adds WALLCHOPS for ircu client compatability" },
+#endif
+
+#ifdef LOCAL_HACKOPS
+  { "LOCAL_HACKOPS", "ON", 0, "Allow LOCAL (&channels) to be hacked by opers" },
+#else
+  { "LOCAL_HACKOPS", "OFF", 0, "Allow LOCAL (&channels) to be hacked by opers" },
+#endif
+
+#ifdef OLD_KNOCK
+  { "OLD_KNOCK", "ON", 0, "Revert KNOCK to previous versions functionality." },
+#else
+  { "OLD_KNOCK", "OFF", 0, "Revert KNOCK to previous versions functionality." },
+#endif
+
+#ifdef SHOW_JUPE_MODE
+  { "SHOW_JUPE_MODE", "ON", 0, "Show +j when a user or oper issues MODE #channel." },
+#else
+  { "SHOW_JUPE_MODE", "OFF", 0, "Show +j when a user or oper issues MODE #channel." },
+#endif
 
   /*
    * since we don't want to include the world here, NULL probably
diff -uNrd ircd-hybrid-6.3.1.dist/include/m_kline.h ircd-hybrid-6.3.1/include/m_kline.h
--- ircd-hybrid-6.3.1.dist/include/m_kline.h	Tue Dec  4 03:26:49 2001
+++ ircd-hybrid-6.3.1/include/m_kline.h	Mon Apr 21 12:04:32 2003
@@ -27,7 +27,6 @@
 {
   struct PKDlines* next;
   struct Client*   sptr;
-  struct Client*   rcptr;
   char*            user; /* username of K/D lined user */
   char*            host; /* hostname of K/D lined user */
   char*            reason; /* reason they are K/D lined */
diff -uNrd ircd-hybrid-6.3.1.dist/include/msg.h ircd-hybrid-6.3.1/include/msg.h
--- ircd-hybrid-6.3.1.dist/include/msg.h	Fri Dec  7 21:38:15 2001
+++ ircd-hybrid-6.3.1/include/msg.h	Mon Apr 21 20:45:20 2003
@@ -116,6 +116,11 @@
 #define MSG_UNKLINE  "UNKLINE"  /* UNKLINE */
 #define MSG_DLINE    "DLINE"    /* DLINE */
 #define MSG_UNDLINE  "UNDLINE"  /* UNDLINE */
+#define MSG_XLINE    "XLINE"    /* XLINE */
+#define MSG_POST     "POST"     /* POST */
+#define MSG_GET      "GET"      /* GET */
+#define MSG_PUT      "PUT"      /* PUT */
+#define MSG_FLAGS    "FLAGS"    /* FLAGS */
 #define MSG_HTM      "HTM"      /* HTM */
 #define MSG_SET      "SET"      /* SET */
 
@@ -128,6 +133,10 @@
 #endif /* LWALLOPS */
 
 #define MSG_KNOCK          "KNOCK"  /* KNOCK */
+#define MSG_MAP            "MAP"    /* MAP */
+#define MSG_ETRACE         "ETRACE"
+#define MSG_ENCAP          "ENCAP"
+#define MSG_WALLCHOPS      "WALLCHOPS" /* WALLCHOPS */
 
 #define MAXPARA    15 
 
@@ -176,11 +185,24 @@
 #ifdef LWALLOPS
   { MSG_LWALLOPS,m_locops,   0, MAXPARA, 1, 0, 0, 0L },
 #endif /* LWALLOPS */
+#ifdef POST_REGISTER
+  { MSG_POST,   m_webproxy,  0, MAXPARA, 1, 1, 0, 0L },
+  { MSG_PUT,    m_webproxy,  0, MAXPARA, 1, 1, 0, 0L },
+  { MSG_GET,    m_webproxy,  0, MAXPARA, 1, 1, 0, 0L },
+#endif /* POST_REGISTER */
+#ifdef FLAGS_COMMAND
+  { MSG_FLAGS,  m_flags,     0, MAXPARA, 1, 0, 0, 0L },
+#endif /* FLAGS_COMMAND */
 
 #ifdef IDLE_FROM_MSG
 
   /* Only m_private has reset idle flag set */
+#ifdef ANTI_IP_SPOOF
+  /* if ANTI_IP_SPOOF, allow user to PONG even when not registered */
+  { MSG_PONG,    m_pong,     0, MAXPARA, 1, 1, 0, 0L },
+#else
   { MSG_PONG,    m_pong,     0, MAXPARA, 1, 0, 0, 0L },
+#endif
   { MSG_PING,    m_ping,     0, MAXPARA, 1, 0, 0, 0L },
 
 #else
@@ -190,7 +212,12 @@
    * when its 0, for IDLE_FROM_MSG ping/pong do not reset idle time
    */
 
+#ifdef ANTI_IP_SPOOF
+  /* if ANTI_IP_SPOOF, allow user to PONG even when not registered */
+  { MSG_PONG,    m_pong,     0, MAXPARA, 1, 1, 0, 0L },
+#else
   { MSG_PONG,    m_pong,     0, MAXPARA, 1, 0, 1, 0L },
+#endif
   { MSG_PING,    m_ping,     0, MAXPARA, 1, 0, 1, 0L },
 
 #endif  /* IDLE_FROM_MSG */
@@ -241,6 +268,9 @@
   { MSG_UNKLINE, m_unkline,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_DLINE,   m_dline,    0, MAXPARA, 1, 0, 0, 0L },
   { MSG_UNDLINE, m_undline,  0, MAXPARA, 1, 0, 0, 0L },
+#ifdef XLINE_COMMAND
+  { MSG_XLINE,   m_xline,    0, MAXPARA, 1, 0, 0, 0L },
+#endif
   { MSG_GLINE,   m_gline,    0, MAXPARA, 1, 0, 0, 0L },
   { MSG_UNGLINE, m_ungline,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_HASH,    m_hash,     0, MAXPARA, 1, 0, 0, 0L },
@@ -253,6 +283,12 @@
   { MSG_HTM,    m_htm,       0, MAXPARA, 1, 0, 0, 0L },
   { MSG_SET,    m_set,       0, MAXPARA, 1, 0, 0, 0L },
   { MSG_TESTLINE,       m_testline,          0, MAXPARA, 1, 0, 0, 0L },
+  { MSG_MAP,    m_map,       0, MAXPARA, 1, 0, 0, 0L },
+  { MSG_ETRACE, m_etrace,    0, MAXPARA, 1, 0, 0, 0L },
+  { MSG_ENCAP,  m_encap,     0, MAXPARA, 1, 0, 0, 0L },
+#ifdef WALLCHOPS
+  { MSG_WALLCHOPS,      m_wallchops,         0, MAXPARA, 1, 0, 0, 0L },
+#endif
   { (char *) 0, (int (*)()) 0 , 0, 0,    0, 0, 0, 0L }
 };
 
diff -uNrd ircd-hybrid-6.3.1.dist/include/numeric.h ircd-hybrid-6.3.1/include/numeric.h
--- ircd-hybrid-6.3.1.dist/include/numeric.h	Thu Dec 13 18:16:34 2001
+++ ircd-hybrid-6.3.1/include/numeric.h	Fri May  2 17:45:33 2003
@@ -29,103 +29,6 @@
 #endif
 
 /*
- * -- Avalon -- 1 Sep 1992
- *
- * Added RPL_TRACELOG, RPL_STATSOLINE
- */
-
-/*
- * -- Avalon -- 13 Aug 1992
- *
- * Added ERR_BADCHANNELKEY, ERR_KEYSET
- */
-
-/*
- * -- Avalon -- 10 Aug 1992
- *
- * Added RPL_SUMMONING
- */
-
-/*
- * -- Avalon -- 5  Jul 1992
- *
- * Added ERR_NICKCOLLISION
- */
-
-/*
- * -- Avalon -- 14 Jul 1992
- *
- * Added RPL_UNAWAY, RPL_NOWAWAY, ERR_NOORIGIN, ERR_FILEERROR, ERR_NOLOGIN,
- * ERR_SUMMONDISABLED, ERR_USERSDISABLED, RPL_USERSSTART, RPL_USERS,
- * RPL_ENDOFUSERS, RPL_NOUSERS
- */
-
-/*
- * -- Avalon -- 12 Jul 1992
- *
- * Added RPL_CLOSING RPL_CLOSEEND
- */
-
-/*
- * -- Avalon -- 10-11 Jul 1992
- *
- * Added RPL_MOTD, RPL_MOTDSTART, RPL_ENDOFMOTD, ERR_NOMOTD,
- * RPL_INFO, RPL_INFOSTART, RPL_ENDOFINFO, ERR_CANTKILLSERVER,
- * RPL_LUSERCLIENT, RPL_LUSEROP, RPL_LUSERUNKNOWN, RPL_LUSERCHAN, RPL_LUSERME,
- * RPL_STATSUPTIME, RPL_ADMINLOC1, RPL_ADMINLOC2, RPL_ADMINME,
- * RPL_ADMINEMAIL, ERR_NOADMININFO
- */
-
-/*
- * -- Avalon -- 28 Jun 1992
- *
- * Added ERR_BADCHANMASK and RPL_ENDOFWHOWAS
- */
-
-/*
- * -- Avalon -- 13 May 1992
- *
- * Added RPL_STATSLLINE
- */
-
-/*
- * -- Avalon -- 12 Jan 1992
- *
- * Added RPL_TRACELINK
- */
-
-/*
- * -- Wumpus -- 30 Nov 1991
- *
- * It's very important that you never change what a numeric means --
- * you can delete old ones (maybe) and add new ones, but never ever
- * take a number and make it suddenly mean something else, or change
- * an old number just for the hell of it.
- */
-
-/*
- * -- avalon -- 19 Nov 1991
- * Added ERR_USERSDONTMATCH 
- *
- * -- avalon -- 06 Nov 1991
- * Added RPL_BANLIST, RPL_BANLISTEND, ERR_BANNEDFROMCHAN
- *
- * -- avalon -- 15 Oct 1991
- * Added RPL_TRACEs (201-209)
- * Added RPL_STATSs (211-219)
- */
-
-/* -- Jto -- 16 Jun 1990
- * A couple of new numerics added...
- */
-
-/* -- Jto -- 03 Jun 1990
- * Added ERR_YOUWILLBEBANNED and Check defines (sigh, had to put 'em here..)
- * Added ERR_UNKNOWNMODE...
- * Added ERR_CANNOTSENDTOCHAN...
- */
-
-/*
  * form_str - return a format string for a message number
  * messages are defined below
  */
@@ -141,6 +44,9 @@
 #define RPL_CREATED          003
 #define RPL_MYINFO           004
 #define RPL_ISUPPORT         005
+#define RPL_MAP              15
+/* #define RPL_MAPMORE          16 */ /* Not currently used */
+#define RPL_MAPEND           17
 
 /*
  * Numeric replies from server commands.
@@ -176,16 +82,18 @@
 
 #define RPL_STATSDLINE       225
 
-#define RPL_SERVLIST         234
-#define RPL_SERVLISTEND      235
+/* #define RPL_SERVLIST         234 */
+/* #define RPL_SERVLISTEND      235 */
 
 #define RPL_STATSLLINE       241
 #define RPL_STATSUPTIME      242
 #define RPL_STATSOLINE       243
 #define RPL_STATSHLINE       244
-#define RPL_STATSSLINE       245
+/* #define RPL_STATSSLINE       245 */
 #define RPL_STATSXLINE       247
-#define RPL_STATSULINE       248
+
+/* RPL_STATSULINE was 248 */
+
 #define RPL_STATSDEBUG       249
 #define RPL_STATSCONN        250
 #define RPL_LUSERCLIENT      251
@@ -198,7 +106,7 @@
 #define RPL_ADMINLOC2        258
 #define RPL_ADMINEMAIL       259
 
-#define RPL_TRACELOG         261
+/* #define RPL_TRACELOG         261 */
 #define RPL_ENDOFTRACE       262
 #define RPL_LOAD2HI          263
 
@@ -239,6 +147,8 @@
 #define RPL_NOTOPIC          331
 #define RPL_TOPIC            332
 
+#define RPL_WHOISACTUALLY    338
+
 #define RPL_INVITING         341
 #define RPL_SUMMONING        342
 
@@ -252,7 +162,7 @@
 #define RPL_NAMREPLY         353
 #define RPL_ENDOFNAMES       366
 
-#define RPL_KILLDONE         361
+/* #define RPL_KILLDONE         361 */
 #define RPL_CLOSING          362
 #define RPL_CLOSEEND         363
 #define RPL_LINKS            364
@@ -271,8 +181,8 @@
 
 #define RPL_YOUREOPER        381
 #define RPL_REHASHING        382
-#define RPL_MYPORTIS         384
-#define RPL_NOTOPERANYMORE   385
+/* #define RPL_MYPORTIS         384 */
+/* #define RPL_NOTOPERANYMORE   385 */
 
 #define RPL_TIME             391
 #define RPL_USERSSTART       392
@@ -298,10 +208,14 @@
 #define ERR_NOTOPLEVEL       413
 #define ERR_WILDTOPLEVEL     414
 
+#ifdef STATS_IGNORED_NOTICE
+#define ERR_STATSIGNORED     419
+#endif
+
 #define ERR_UNKNOWNCOMMAND   421
 #define ERR_NOMOTD           422
 #define ERR_NOADMININFO      423
-#define ERR_FILEERROR        424
+/* #define ERR_FILEERROR        424 */
 
 #define ERR_NONICKNAMEGIVEN  431
 #define ERR_ERRONEUSNICKNAME 432
@@ -314,8 +228,8 @@
 #define ERR_NOTONCHANNEL     442
 #define ERR_USERONCHANNEL    443
 #define ERR_NOLOGIN          444
-#define ERR_SUMMONDISABLED   445
-#define ERR_USERSDISABLED    446
+/* #define ERR_SUMMONDISABLED   445 */
+/* #define ERR_USERSDISABLED    446 */
 
 #define ERR_NOTREGISTERED    451
 
@@ -324,8 +238,8 @@
 #define ERR_NOPERMFORHOST    463
 #define ERR_PASSWDMISMATCH   464
 #define ERR_YOUREBANNEDCREEP 465
-#define ERR_YOUWILLBEBANNED  466
-#define ERR_KEYSET           467
+/* #define ERR_YOUWILLBEBANNED  466 */
+/* #define ERR_KEYSET           467 */
 
 #define ERR_CHANNELISFULL    471
 #define ERR_UNKNOWNMODE      472
@@ -333,14 +247,15 @@
 #define ERR_BANNEDFROMCHAN   474
 #define ERR_BADCHANNELKEY    475
 #define ERR_BADCHANMASK      476
-#define ERR_MODELESS         477        /* ircu numeric -db */
+/* #define ERR_MODELESS         477        */ /* ircu numeric -db */
 #define ERR_BANLISTFULL      478        /* I stole the numeric from ircu -db */
 #define ERR_BADCHANNAME      479
 
 #define ERR_NOPRIVILEGES     481
 #define ERR_CHANOPRIVSNEEDED 482
 #define ERR_CANTKILLSERVER   483
-#define ERR_DESYNC           484
+#define ERR_RESTRICTED       484        /* Stolen from IRCnet -Hwy */
+#define ERR_DESYNC           484        /* Not anymore... */
 
 #define ERR_NOOPERHOST       491
 
@@ -348,6 +263,18 @@
 #define ERR_USERSDONTMATCH   502
 
 #define ERR_GHOSTEDCLIENT    503
-#define ERR_LAST_ERR_MSG     504
+
+#define RPL_ETRACE           709
+
+#define RPL_KNOCK            710
+#define RPL_KNOCKDLVR        711
+ 
+#define ERR_TOOMANYKNOCK     712
+#define ERR_CHANOPEN         713
+#define ERR_KNOCKONCHAN      714
+#define ERR_KNOCKDISABLED    715
+
+
+#define ERR_LAST_ERR_MSG     999
 
 #endif /* INCLUDED_numeric_h */
diff -uNrd ircd-hybrid-6.3.1.dist/include/patchlevel.h ircd-hybrid-6.3.1/include/patchlevel.h
--- ircd-hybrid-6.3.1.dist/include/patchlevel.h	Wed Apr 17 22:54:49 2002
+++ ircd-hybrid-6.3.1/include/patchlevel.h	Thu May  8 12:44:31 2003
@@ -19,5 +19,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "2.8/hybrid-6.3.1"
+#define PATCHLEVEL    "2.8/hybrid-6.3.1+fr25pre-fixed"
 #endif
diff -uNrd ircd-hybrid-6.3.1.dist/include/res.h ircd-hybrid-6.3.1/include/res.h
--- ircd-hybrid-6.3.1.dist/include/res.h	Mon Dec  3 23:47:44 2001
+++ ircd-hybrid-6.3.1/include/res.h	Sat Apr 19 21:15:38 2003
@@ -29,8 +29,8 @@
 void dns_readable (int fd , void *ptr );
 void dns_do_callbacks(void);
 void dns_select (void);
-void adns_gethost (const char *name, struct DNSQuery *req );
-void adns_getaddr (struct in_addr *addr , struct DNSQuery *req );
+int adns_gethost (const char *name, struct DNSQuery *req );
+int adns_getaddr (struct in_addr *addr , struct DNSQuery *req );
 void delete_adns_queries(struct DNSQuery *q);
 void do_adns_io();
 #endif
diff -uNrd ircd-hybrid-6.3.1.dist/include/s_conf.h ircd-hybrid-6.3.1/include/s_conf.h
--- ircd-hybrid-6.3.1.dist/include/s_conf.h	Fri Dec 14 21:42:01 2001
+++ ircd-hybrid-6.3.1/include/s_conf.h	Tue Apr 22 10:08:07 2003
@@ -96,7 +96,6 @@
 #define CONF_FLINE              0x8000
 #define CONF_DLINE              0x20000
 #define CONF_XLINE              0x40000
-#define CONF_ULINE              0x80000
 
 #define CONF_OPS                (CONF_OPERATOR | CONF_LOCOP)
 #define CONF_SERVER_MASK        (CONF_CONNECT_SERVER | CONF_NOCONNECT_SERVER)
@@ -128,9 +127,15 @@
 #define CONF_FLAGS_LITTLE_I_LINE        0x8000
 #endif
 
+#define CONF_FLAGS_RESOLVE             0x10000
+
+#ifdef CHECK_CLONE
+#define CONF_FLAGS_CLONE_EXEMPT        0x20000
+#endif
 
 /* Macros for aConfItem */
 
+#define IsMustResolve(x)        ((x)->flags & CONF_FLAGS_RESOLVE)
 #define IsLimitIp(x)            ((x)->flags & CONF_FLAGS_LIMIT_IP)
 #define IsNoTilde(x)            ((x)->flags & CONF_FLAGS_NO_TILDE)
 #define IsNeedIdentd(x)         ((x)->flags & CONF_FLAGS_NEED_IDENTD)
@@ -150,6 +155,10 @@
 #define IsConfLittleI(x)        ((x)->flags & CONF_FLAGS_LITTLE_I_LINE)
 #endif
 
+#ifdef CHECK_CLONE
+#define IsConfCloneExempt(x)    ((x)->flags & CONF_FLAGS_CLONE_EXEMPT)
+#endif
+
 /* port definitions for Opers */
 
 #define CONF_OPER_GLOBAL_KILL 1
@@ -160,6 +169,7 @@
 #define CONF_OPER_K          32
 #define CONF_OPER_REHASH     64
 #define CONF_OPER_DIE       128
+#define CONF_OPER_ADMIN     256
 
 typedef struct
 {
@@ -178,8 +188,6 @@
 } ConfigFileEntryType;
 
 /* aConfItems */
-/* conf uline link list root */
-extern struct ConfItem *u_conf;
 /* conf xline link list root */
 extern struct ConfItem *x_conf;
 /* conf qline link list root */
@@ -189,6 +197,7 @@
 extern int              specific_virtual_host; /* GLOBAL - used in s_bsd.c */
 extern struct ConfItem *temporary_klines;
 extern struct ConfItem *temporary_ip_klines;
+extern struct ConfItem *temporary_dlines;
 extern ConfigFileEntryType ConfigFileEntry;    /* GLOBAL - defined in ircd.c */
 
 extern void clear_ip_hash_table(void);
@@ -241,9 +250,16 @@
 extern struct ConfItem* is_klined(const char *host,
                                   const char *name,
 				  unsigned long ip);
+extern struct ConfItem* is_tklined(const char *host,
+                                   const char *name,
+                                   unsigned long ip);
+extern struct ConfItem* is_pklined(const char *host,
+                                   const char *name,
+                                   unsigned long ip);
 extern struct ConfItem* find_is_klined(const char* host, 
                                        const char* name,
                                        unsigned long ip);
+extern struct ConfItem *find_tdline(unsigned long ip);
 extern char* show_iline_prefix(struct Client *,struct ConfItem *,char *);
 extern void get_printable_conf(struct ConfItem *,
 			       char **, char **, char **, char **, int *);
@@ -256,23 +272,21 @@
 typedef enum {
   CONF_TYPE,
   KLINE_TYPE,
+#ifdef XLINE_COMMAND
+  DLINE_TYPE,
+  XLINE_TYPE
+#else
   DLINE_TYPE
+#endif
 } KlineType;
 
-extern void write_kline_or_dline_to_conf_and_notice_opers(
-                                                          KlineType,
-                                                          struct Client *,
-                                                          struct Client *,
-                                                          char *,
-                                                          char *,
-                                                          char *,
-                                                          char *
-                                                          );
 extern const char *get_conf_name(KlineType);
 extern int safe_write(struct Client *, const char *, int ,char *);
 extern void add_temp_kline(struct ConfItem *);
+extern void add_temp_dline(struct ConfItem *);
 extern  void    flush_temp_klines(void);
 extern  void    report_temp_klines(struct Client *);
+extern void report_temp_dlines(struct Client *);
 extern  void    show_temp_klines(struct Client *, struct ConfItem *);
 extern  int     is_address(char *,unsigned long *,unsigned long *); 
 extern  int     rehash (struct Client *, struct Client *, int);
diff -uNrd ircd-hybrid-6.3.1.dist/include/s_misc.h ircd-hybrid-6.3.1/include/s_misc.h
--- ircd-hybrid-6.3.1.dist/include/s_misc.h	Thu Dec 13 18:16:34 2001
+++ ircd-hybrid-6.3.1/include/s_misc.h	Thu May  1 11:46:00 2003
@@ -18,6 +18,7 @@
 extern char    *small_file_date(time_t);
 
 extern char *make_isupport();
+int oper_time(char *);
 #endif
 
 
diff -uNrd ircd-hybrid-6.3.1.dist/include/s_serv.h ircd-hybrid-6.3.1/include/s_serv.h
--- ircd-hybrid-6.3.1.dist/include/s_serv.h	Sun Dec  9 14:02:09 2001
+++ ircd-hybrid-6.3.1/include/s_serv.h	Mon Apr 21 14:30:35 2003
@@ -45,6 +45,9 @@
 #define CAP_EX          0x00000008      /* Can do channel +e exemptions */
 #define CAP_CHW         0x00000010      /* Can do channel wall @# */
 #define CAP_KNOCK	0x00000020
+#define CAP_KLN		0x00000040
+#define CAP_UNKLN	0x00000080
+#define CAP_ENCAP	0x00000100
 
 #define DoesCAP(x)      ((x)->caps)
 
diff -uNrd ircd-hybrid-6.3.1.dist/include/s_stats.h ircd-hybrid-6.3.1/include/s_stats.h
--- ircd-hybrid-6.3.1.dist/include/s_stats.h	Fri Jul 30 16:14:04 1999
+++ ircd-hybrid-6.3.1/include/s_stats.h	Sat Apr 19 21:06:44 2003
@@ -65,6 +65,9 @@
 #ifdef FLUD
   unsigned int    is_flud;        /* users/channels flood protected */
 #endif /* FLUD */
+#ifdef ANTI_IP_SPOOF
+  unsigned int    is_ipspoof;
+#endif
 };
 
 extern struct ServerStatistics* ServerStats;
diff -uNrd ircd-hybrid-6.3.1.dist/include/s_user.h ircd-hybrid-6.3.1/include/s_user.h
--- ircd-hybrid-6.3.1.dist/include/s_user.h	Wed Oct 17 11:13:31 2001
+++ ircd-hybrid-6.3.1/include/s_user.h	Sat May  3 10:21:54 2003
@@ -40,6 +40,8 @@
 extern void  send_umode_out (struct Client*, struct Client *, int);
 extern int   show_lusers(struct Client *, struct Client *, int, char **);
 extern void  show_opers(struct Client* client);
+extern char  oper_type_char(struct Client *);
 
+extern int   register_user(struct Client *, struct Client *, char *, char *);
 
 #endif
diff -uNrd ircd-hybrid-6.3.1.dist/include/send.h ircd-hybrid-6.3.1/include/send.h
--- ircd-hybrid-6.3.1.dist/include/send.h	Sat Feb  2 15:58:27 2002
+++ ircd-hybrid-6.3.1/include/send.h	Fri May  2 18:23:48 2003
@@ -19,7 +19,7 @@
 
 /* send.c prototypes */
 
-extern  void send_operwall(struct Client *,char *,char *);
+extern  void send_operwall(struct Client *,char *,char *, int);
 extern  void sendto_channel_type_notice(struct Client *, 
                                         struct Channel *, int, char *);
 extern  void send_knock(struct Client *, struct Client *, 
diff -uNrd ircd-hybrid-6.3.1.dist/include/serno.h ircd-hybrid-6.3.1/include/serno.h
--- ircd-hybrid-6.3.1.dist/include/serno.h	Wed Apr 17 23:16:00 2002
+++ ircd-hybrid-6.3.1/include/serno.h	Sat Apr 19 21:06:44 2003
@@ -1 +1 @@
-#define SERIALNUM "20020418_1"
+#define SERIALNUM "20020802_0"
diff -uNrd ircd-hybrid-6.3.1.dist/include/setup.h.in ircd-hybrid-6.3.1/include/setup.h.in
--- ircd-hybrid-6.3.1.dist/include/setup.h.in	Sun Jan 27 23:36:54 2002
+++ ircd-hybrid-6.3.1/include/setup.h.in	Sat Apr 19 21:06:44 2003
@@ -1,5 +1,4 @@
-/* $Id: setup.h.in,v 1.17 2002/01/28 04:36:54 androsyn Exp $ */
-/* include/setup.h.in.  Generated automatically from autoconf/configure.in by autoheader 2.13.  */
+/* include/setup.h.in.  Generated automatically from configure.in by autoheader.  */
 
 /* Define if you have a working `mmap' system call.  */
 #undef HAVE_MMAP
@@ -36,6 +35,9 @@
 /* Define if you have SYSV non-blocking sockets (FIONBIO) */
 #undef NBLOCK_SYSV
 
+/* Define if you have the setlocale() system call.  */
+#undef USE_SETLOCALE
+
 /* Define if you have the getpagesize function.  */
 #undef HAVE_GETPAGESIZE
 
@@ -47,6 +49,9 @@
 
 /* Define if you have the <getopt.h> header file.  */
 #undef HAVE_GETOPT_H
+
+/* Define if you have the <locale.h> header file.  */
+#undef HAVE_LOCALE_H
 
 /* Define if you have the <stddef.h> header file.  */
 #undef HAVE_STDDEF_H
